<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 48.10- Ôn Thi</title>

    <!-- Select2 -->
    <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
    <!-- daterange picker -->
    <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>

<body class="hold-transition sidebar-mini">
    <div class="wrapper">


        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="index3.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Admin</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image col-sm-5">
                        <img src="dist/img/hinhconde.jpg" class="img-circle elevation-2 w-100" alt="User Image">
                    </div>
                    <div class="info col-sm-7">
                        <a href="#" class="d-block"><b>Huy Nguyễn 18+</b></a>
                    </div>
                </div>

                <!-- SidebarSearch Form -->
                <div class="form-inline">
                    <div class="input-group" data-widget="sidebar-search">
                        <input class="form-control form-control-sidebar" type="search" placeholder="Search"
                            aria-label="Search">
                        <div class="input-group-append">
                            <button class="btn btn-sidebar">
                                <i class="fas fa-search fa-fw"></i>
                            </button>
                        </div>
                    </div>
                </div>

                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open" style="background-color:grey">
                            <a href="#" class="nav-link active" style="background-color:grey">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="https://ironhackvietnam.edu.vn/" class="nav-link active">
                                        <i class="fas fa-book nav-icon"></i>
                                        <p>Tìm Hiểu Ironhack</p>
                                    </a>
                                </li>

                            </ul>
                        </li>

                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <button id="btn-change-style" class="btn btn-dark"><i class="fas fa-exchange"></i></i>&nbsp;Chuyển sang xem nền sáng</button>
                        </div>
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Devcamp</li>
                            </ol>
                        </div>
                    </div>
                </div><!-- /.container-fluid -->
            </section>

            <!-- Main Content-->
            <div class="container">
                <div class="form-group">
                    <div class="text-center mt-2 mb-2">
                        <h2><b>F200 - LỊCH SỬ HỌC TẬP</b></h2>
                    </div>
                    <div class="jumbotron container">
                        <h2><b>Lọc bảng điểm </b></h2>
                        <br>
                        <div class="row form-group">
                            <div class="col-sm-5">
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="roleInput">Sinh viên &nbsp;<i class="fa fa-graduation-cap"></i></label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select id="inp-student" class="form-control select2 bg-info">
                                        </select>
                                    </div>
                                </div>
                            </div>

                            <div class="col-sm-5">
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label for="roleInput">Môn học &nbsp;<i class="fa fa-book"></i></label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select id="inp-subject" class="form-control select2 bg-info">
                                        </select>
                                    </div>
                                </div>
                            </div>

                            <div class="col-sm-2">
                                <div class="row form-group">
                                    <button id="btn-filter-student" style="background-color:grey"><a class="fa fa-filter text-white"></a>&nbsp;<b>Lọc dữ liệu</b></button>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <button class="btn btn-dark"  id="btn-add"><i  class="fa fa-plus"></i>&nbsp; <b>Thêm</b></button>
                    </div>

                    <div class="container">
                        <table class="table table-bordered table-striped table-hover" id="student-table">
                            <thead>
                                <tr class="bg-dark">
                                    <th>STT</th>
                                    <th>Sinh viên</th>
                                    <th>Môn học</th>
                                    <th>Điểm</th>
                                    <th>Ngày thi</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody></tbody>
                        </table>
                    </div>
                </div>
                <!-- Vùng Modal -->

                <!-- Create Student modal -->
                <div>
                    <div id="create-student-modal" class="modal fade" tabindex="-1">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="h5-modal-title">Create new Student</h5>
                                    <button class="close" data-dismiss="modal">&times;</button>
                                </div>
                                <div class="modal-body">
                                    <form>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-create-student-id">Student ID</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <select type="text" id="input-create-student-id" name="Student ID"
                                                    placeholder="..." class="form-control select2"></select>
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-create-discount">Subject Id</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <select type="text" id="input-create-subject-id" name="subjectId"
                                                    placeholder="...." class="form-control select2"></select>
                                            </div>
                                        </div>

                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-create-grade"> Grade</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="number" id="input-create-grade" name="grade"
                                                    placeholder="...." class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-create-exam-date"> ExamDate</label>
                                            </div>
                                            <div class="col-sm-8">

                                                <div class="input-group date" id="reservationdate"
                                                    data-target-input="nearest">
                                                    <input type="text" class="form-control datetimepicker-input"
                                                        data-target="#reservationdate" />
                                                    <div class="input-group-append" data-target="#reservationdate"
                                                        data-toggle="datetimepicker">
                                                        <div class="input-group-text"><i class="fa fa-calendar"></i>
                                                        </div>
                                                    </div>
                                                </div>
                                                <!-- <input type="text" id="input-create-exam-date" name="examDate"
                                                    placeholder="...." class="form-control"> -->
                                            </div>
                                        </div>


                                    </form>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-secondary" id="btn-create-cancel"
                                        data-dismiss="modal">Cancel</button>
                                    <button class="btn btn-primary" id="btn-create-student">Create Student</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Edit Student modal -->
                <div>
                    <div id="edit-student-modal" class="modal fade" tabindex="-1">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="h5-modal-title">edit Student</h5>
                                    <button class="close" data-dismiss="modal">&times;</button>
                                </div>
                                <div class="modal-body">
                                    <form>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-edit-student-id">Student ID</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <select type="text" id="input-edit-student-id" name="Student ID"
                                                    placeholder="..." class="form-control select2"></select>
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-edit-subject-id">Subject Id</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <select type="text" id="input-edit-subject-id" name="subjectId"
                                                    placeholder="...." class="form-control select2"></select>
                                            </div>
                                        </div>

                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-edit-grade"> Grade</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="number" id="input-edit-grade" name="grade"
                                                    placeholder="...." class="form-control">
                                            </div>
                                        </div>
                                        <div class="row form-group">
                                            <div class="col-sm-4">
                                                <label for="input-edit-exam-date"> Exam Date</label>
                                            </div>
                                            <div class="col-sm-8">
                                                <input type="text" id="input-edit-exam-date" name="examDate"
                                                    placeholder="...." class="form-control">
                                            </div>
                                        </div>


                                    </form>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-secondary" id="btn-edit-cancel"
                                        data-dismiss="modal">Cancel</button>
                                    <button class="btn btn-primary" id="btn-edit-student">Edit Student</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Delete Student modal -->
                <div>
                    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                        <div class="modal-dialog">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="h5-modal-title">Student Delete Confirmation</h5>
                                    <button class="close" data-dismiss="modal">&times;</button>
                                </div>
                                <div class="modal-body">
                                    <label>Bạn có chắc chắn muốn xóa Student này không?</label>
                                </div>
                                <div class="modal-footer">
                                    <button class="btn btn-danger" id="btn-confirm-delete-student">Confirm</button>
                                    <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <!-- /.content -->
        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer no-print">
            <div class="float-right d-none d-sm-block">
                <b>Version</b> 3.2.0
            </div>
            <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights
            reserved.
        </footer>


    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>



    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="plugins/moment/moment.min.js"></script>
    <!-- date-range-picker -->
    <script src="plugins/daterangepicker/daterangepicker.js"></script>
    <!-- Select2 -->
    <script src="plugins/select2/js/select2.full.min.js"></script>


    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>

    <!-- <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> -->
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


    <script>

        //Initialize Select2 Elements
        $('.select2').select2();

        //Initialize Select2 Elements
        $('.select2').select2({
            theme: 'bootstrap4'
        });
        //Date picker
        $('#reservationdate').daterangepicker({
            singleDatePicker: true,
            showDropdowns: true,
            format: 'L'
        });

    </script>

    <script>
        const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
        const gCONTENT_TYPE = "application/json;charset=UTF-8";
        const ARRAY_TABLE_COL = ['id', 'studentId', 'subjectId', 'grade', 'examDate', 'action']
        const COL_ID = 0;
        const COL_STUDENT_ID = 1;
        const COL_SUBJECT_ID = 2;
        const COL_GRADE = 3;
        const COL_EXAM_DATE = 4;
        const COL_ACTION = 5;
        var gSTT = 0;
        var gStudents = [];
        var gSubjects = [];
        var gGrade = [];
        var gStudentId = 0;
        var gStudentTable = $("#student-table").DataTable({

            columns: [
                { data: ARRAY_TABLE_COL[COL_ID] },
                { data: ARRAY_TABLE_COL[COL_STUDENT_ID] },
                { data: ARRAY_TABLE_COL[COL_SUBJECT_ID] },
                { data: ARRAY_TABLE_COL[COL_GRADE] },
                { data: ARRAY_TABLE_COL[COL_EXAM_DATE] },
                { data: ARRAY_TABLE_COL[COL_ACTION] },
            ],
            columnDefs: [
                {
                    targets: COL_ID, // cột ID
                    className: "text-center",
                    render: function (data, type, row, meta) {
                        return meta.row + meta.settings._iDisplayStart + 1;
                    }

                },
                {
                    targets: COL_STUDENT_ID, // cột student CODE
                    className: "text-center",
                    render: function (paramStudentId) {
                        return getNameStudentByStudentId(paramStudentId);
                    }

                },
                {
                    targets: COL_SUBJECT_ID, // cột Subject CODE
                    className: "text-center",
                    render: function (paramsubjectId) {

                        return getSubjectBySubjectId(paramsubjectId);
                    }

                },
                { // định nghĩa lại cột action
                    targets: COL_ACTION,
                    defaultContent: `
            <img class="edit-voucher" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
            <img class="delete-voucher" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
          `
                }
            ]
        })
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */


        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        //  onPageLoading();
        $(document).ready(function () {
            // thực hiện tải trang
            onPageLoading();
            // 2 - C: gán sự kiện Create - Thêm mới Student
            $("#btn-add").on("click", function () {
                $("#create-student-modal").modal("show");
            });
            // 3 - U: gán sự kiện Update - Sửa 1 voucher
            $("#student-table").on("click", ".edit-voucher", function () {
                onBtnEditVoucherClick(this);
            });
            // gán sự kiện tạo mới 1 Student
            $("#btn-create-student").on("click", function () {
                onBtnCreateStudentClick();
            })
            // 4 - U: gán sự kiện Delete - xóa 1 Student
            $("#student-table").on("click", ".delete-voucher", function () {
                onBtnDeleteVoucherClick(this);
            });
            // gán sự kiện cho nút Update Student (trên modal)
            $("#btn-edit-student").on("click", function () {
                onBtnUpdateVoucherClick();
            });
            $("#btn-change-style").on("click",function(){
                window.location.href="style_blue.html";
            });


            // gán sự kiện cho nút Delete Student (trên modal)
            $("#btn-confirm-delete-student").on("click", function () {
                onBtnConfirmDeleteStudentClick()
            })
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm khi vừa tải trang
        function onPageLoading() {
            callAPIStudent();
            callAPISubject();
            callAPIGrade();
        }
        // nút lọc 
        $("#btn-filter-student").on("click", function () {
            onBtnFilterClick();
        })
        // Hàm xử lý sự kiện khi icon delete voucher trên bảng đc click
        function onBtnDeleteVoucherClick(paramBtnEdit) {
            // lưu thông tin voucherId đang được edit vào biến toàn cục
            gStudentId = getStudentIdFromButton(paramBtnEdit);

            $("#delete-confirm-modal").modal("show");
        }

        // hàm xử lý sự kiện update voucher modal click
        function onBtnUpdateVoucherClick() {
            // khai báo đối tượng chứa voucher data
            var vGradeObjRequest = {
                studentId: "",
                subjectId: "",
                grade: 0,
                examDate: 0,
            };
            // B1: Thu thập dữ liệu
            getEditStudentData(vGradeObjRequest);
            // B2: Validate update
            var vIsStudentValidate = validateStudentData(vGradeObjRequest);
            if (vIsStudentValidate) {
                // B3: update voucher
                $.ajax({
                    url: gBASE_URL + "/grades/" + gStudentId,
                    type: "PUT",
                    contentType: gCONTENT_TYPE,
                    data: JSON.stringify(vGradeObjRequest),
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleEditStudentSuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
            }
        }

        // Hàm xử lý sự kiện khi icon edit voucher trên bảng đc click
        function onBtnEditVoucherClick(paramBtnEdit) {
            // lưu thông tin voucherId đang được edit vào biến toàn cục
            gStudentId = getStudentIdFromButton(paramBtnEdit);
            // load dữ liệu vào các trường dữ liệu trong modal
            getVoucherById(gStudentId);
        }

        // hàm xử lý sự kiện create voucher modal click
        function onBtnCreateStudentClick() {
            // khai báo đối tượng chứa voucher data
            var vStudentObj = {
                studentId: 0,
                subjectId: 0,
                grade: "",
                examDate: "",
            };
            // B1: Thu thập dữ liệu
            getCreateStudentData(vStudentObj);
            console.log(vStudentObj);
            // B2: Validate insert
            var vIsStudentValidate = validateStudentData(vStudentObj);
            if (vIsStudentValidate) {
                // B3: insert voucher
                $.ajax({
                    url: gBASE_URL + "/grades",
                    type: "POST",
                    contentType: gCONTENT_TYPE,
                    data: JSON.stringify(vStudentObj),
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleInsertStudentSuccess()
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
            }
        }
        // hàm thu thập dự liệu để tạo mới 1 student
        function getCreateStudentData(paramStudentData) {
            paramStudentData.studentId = $("#input-create-student-id").val()
            paramStudentData.subjectId = $("#input-create-subject-id").val()
            paramStudentData.grade = $("#input-create-grade").val()
            paramStudentData.examDate = $("#input-create-exam-date").val()
        }
        // hàm thu thập dự liệu để sửa 1 student
        function getEditStudentData(paramStudentData) {
            paramStudentData.studentId = $("#input-edit-student-id").val()
            paramStudentData.subjectId = $("#input-edit-subject-id").val()
            paramStudentData.grade = $("#input-edit-grade").val()
            paramStudentData.examDate = $("#input-edit-exam-date").val()
        }
        // hàm kiểm tra dữ liệu để tạo mới 1 student
        function validateStudentData(paramStudentData) {
            if (paramStudentData.studentId == 0) {
                $(document).Toasts('create', {
                    class: 'bg-danger',
                    title: 'Thông báo                     ',
                    subtitle: 'Subtitle ',
                    body: ' bạn cần phải nhập studentId trước khi tạo mới !'
                })
                return false;
            }
            if (paramStudentData.subjectId == 0) {
                $(document).Toasts('create', {
                    class: 'bg-danger',
                    title: 'Thông báo                     ',
                    subtitle: 'Subtitle ',
                    body: ' bạn cần phải nhập subjectId trước khi tạo mới !'
                })
                return false;
            }
            if (paramStudentData.grade == "") {
                $(document).Toasts('create', {
                    class: 'bg-danger',
                    title: 'Thông báo                     ',
                    subtitle: 'Subtitle ',
                    body: ' bạn cần phải nhập Grade trước khi tạo mới !'
                })
                return false;
            }
            if (paramStudentData.grade < 0 || 11 <= paramStudentData.grade) {
                $(document).Toasts('create', {
                    class: 'bg-danger',
                    title: 'Thông báo                     ',
                    subtitle: 'Subtitle ',
                    body: ' Grade lớn hơn 0 và bé hơn hoặc bằng 10!'
                })

                return false;
            }
            if (paramStudentData.examDate == "") {
                $(document).Toasts('create', {
                    class: 'bg-danger',
                    title: 'Thông báo                     ',
                    subtitle: 'Subtitle ',
                    body: ' bạn cần phải nhập ExamDate trước khi tạo mới !'
                })

                return false;
            }
            return true;
        }
        // hàm gọi API Student
        function callAPIStudent() {
            $.ajax({
                url: gBASE_URL + "/students",
                type: 'GET',
                dataType: 'json', // added data type
                success: function (responseObject) {
                    gStudents = responseObject;
                    console.log("Danh sách học sinh : ");
                    console.log(gStudents);
                    // đẩy data học sinh vào ô select
                    loadDataStudentToSelect(gStudents);
                    loadDataStudentToSelectModal(gStudents);
                    loadDataStudentToSelectEditModal(gStudents);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                }
            });
        }

        // hàm gọi API Subject
        function callAPISubject() {
            $.ajax({
                url: gBASE_URL + "/subjects",
                type: 'GET',
                dataType: 'json', // added data type
                success: function (responseObject) {
                    console.log("Danh sách  Môn học : ");
                    gSubjects = responseObject;
                    console.log(gSubjects);
                    // đẩy data Subjects  vào ô select
                    loadDataSubjectToSelect(gSubjects);
                    loadDataSubjectToSelectModal(gSubjects);
                    loadDataSubjectToSelectEditModal(gSubjects);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                }
            });
        }

        // hàm gọi API Grade
        function callAPIGrade() {
            $.ajax({
                url: gBASE_URL + "/grades",
                type: 'GET',
                dataType: 'json', // added data type
                success: function (responseObject) {
                    console.log("Danh sách điểm : ");
                    gGrade = responseObject;
                    console.log(gGrade);
                    loadDataIntoTable(responseObject);
                },
                error: function (ajaxContext) {
                    alert(ajaxContext.responseText)
                }
            });
        }
        // hàm trả về tên học sinh dựa vào studentID
        function getNameStudentByStudentId(paramStudentId) {
            var vStudentFullname = "";
            var vIndex = 0;
            var vIsTypeFound = false;
            while (!vIsTypeFound && vIndex < gStudents.length) {
                if (gStudents[vIndex].id === paramStudentId) {
                    vIsTypeFound = true;
                    vStudentFullname = gStudents[vIndex].firstname + " " + gStudents[vIndex].lastname;
                }
                else {
                    vIndex++;
                }
            }
            return vStudentFullname;
        };
        // hàm trả về môn học dựa vào SubjectID
        function getSubjectBySubjectId(paramsubjectId) {
            var vSubject = "";
            var vIndex = 0;
            var vIsTypeFound = false;
            while (!vIsTypeFound && vIndex < gSubjects.length) {
                if (gSubjects[vIndex].id === paramsubjectId) {
                    vIsTypeFound = true;
                    vSubject = gSubjects[vIndex].subjectName;
                }
                else {
                    vIndex++;
                }
            }
            return vSubject;
        };
        // hàm đẩy data Student vào select
        function loadDataStudentToSelect(paramStudent) {
            $("#inp-student").empty();
            $("#inp-student").append($("<option>", {
                value: 0,
                text: "Chọn Học Sinh ",
            }));
            for (var bI = 0; bI < paramStudent.length; bI++) {
                $("#inp-student").append($("<option>", {
                    value: paramStudent[bI].id,
                    text: paramStudent[bI].firstname + " " + paramStudent[bI].lastname,
                }));
            }
        }
        // hàm đẩy data Subject vào select
        function loadDataSubjectToSelect(paramSubject) {
            $("#inp-subject").empty();
            $("#inp-subject").append($("<option>", {
                value: 0,
                text: "Chọn môn học",
            }));
            for (var bI = 0; bI < paramSubject.length; bI++) {
                $("#inp-subject").append($("<option>", {
                    value: paramSubject[bI].id,
                    text: paramSubject[bI].subjectName,
                }));
            }
        }
        // hàm get voucher by id
        function getVoucherById(paramStudentId) {
            $.ajax({
                url: gBASE_URL + "/grades/" + paramStudentId,
                type: "GET",
                success: function (paramStudent) {
                    console.log(paramStudent);
                    showVoucherDataToModal(paramStudent);
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });
            // hiển thị modal lên
            $("#edit-student-modal").modal("show");
        }
        // hàm show voucher obj lên modal
        function showVoucherDataToModal(paramStudent) {
            $("#input-edit-student-id").val(paramStudent.studentId);
            $("#input-edit-subject-id").val(paramStudent.subjectId);
            $("#input-edit-grade").val(paramStudent.grade);
            $("#input-edit-exam-date").val(paramStudent.examDate);
        }
        // Modal 
        // hàm đẩy data Student vào select
        function loadDataStudentToSelectModal(paramStudent) {
            $("#input-create-student-id").empty();
            $("#input-create-student-id").append($("<option>", {
                value: 0,
                text: "Chọn Học Sinh ",
            }));
            for (var bI = 0; bI < paramStudent.length; bI++) {
                $("#input-create-student-id").append($("<option>", {
                    value: paramStudent[bI].id,
                    text: paramStudent[bI].firstname + " " + paramStudent[bI].lastname,
                }));
            }
        }
        // hàm đẩy data Subject vào select
        function loadDataSubjectToSelectModal(paramSubject) {
            $("#input-create-subject-id").empty();
            $("#input-create-subject-id").append($("<option>", {
                value: 0,
                text: "Chọn môn học",
            }));
            for (var bI = 0; bI < paramSubject.length; bI++) {
                $("#input-create-subject-id").append($("<option>", {
                    value: paramSubject[bI].id,
                    text: paramSubject[bI].subjectName,
                }));
            }
        }
        ///                            đẩy dự liệu vào select EDIT MODAL
        // hàm đẩy data Student vào select
        function loadDataStudentToSelectEditModal(paramStudent) {
            $("#input-edit-student-id").empty();
            $("#input-edit-student-id").append($("<option>", {
                value: 0,
                text: "Chọn Học Sinh ",
            }));
            for (var bI = 0; bI < paramStudent.length; bI++) {
                $("#input-edit-student-id").append($("<option>", {
                    value: paramStudent[bI].id,
                    text: paramStudent[bI].firstname + " " + paramStudent[bI].lastname,
                }));
            }
        }
        // hàm đẩy data Subject vào select
        function loadDataSubjectToSelectEditModal(paramSubject) {
            $("#input-edit-subject-id").empty();
            $("#input-edit-subject-id").append($("<option>", {
                value: 0,
                text: "Chọn môn học",
            }));
            for (var bI = 0; bI < paramSubject.length; bI++) {
                $("#input-edit-subject-id").append($("<option>", {
                    value: paramSubject[bI].id,
                    text: paramSubject[bI].subjectName,
                }));
            }
        }


        ///--                          đẩy dự liệu vào select EDIT MODAL



        // Modal 


        // hàm xử lý khi click nút lọc dữ liệu
        function onBtnFilterClick() {
            // B0: tạo đối tượng chứa điều kiện lọc
            var vFilter = {
                student: 0,
                subject: 0,
            }

            // B1: thu thập dự liệu
            getDataFormSelect(vFilter);
            console.log(vFilter);
            // B2: kiểm tra dự liệu

            // B3: lọc dự liệu
            var vResultFilter = findStudentAndSubjectByFilter(vFilter)
            console.log(vResultFilter);
            // B4: hiện thị kết quả lọc ra dataTable
            $("#student-table").find("tr:gt(0)").html("");
            if (vResultFilter.length > 0) {
                $(document).Toasts('create', {
                    class: 'bg-success',
                    title: 'Tìm kiếm thành công                     ',
                    subtitle: 'Subtitle ',
                    body: "Đã tìm thấy: " + vResultFilter.length + " kết quả !"
                })

                loadDataIntoTable(vResultFilter);
            } else {
                loadDataIntoTable(gGrade);
                $(document).Toasts('create', {
                    class: 'bg-warning',
                    title: 'Chú ý ',
                    subtitle: 'Subtitle ',
                    body: 'KHÔNG có kết quả cho học sinh này'
                })
                return false;

            }
        };

        // hàm thu thập dữ liệu trên select 
        function getDataFormSelect(paramData) {
            paramData.student = $("#inp-student").val();
            paramData.subject = $("#inp-subject").val();
        }
        // hàm xử lý việc tìm kiếm user
        function findStudentAndSubjectByFilter(paramStudent) {

            const bArresutObj = [];
            // kiểm tra trường hợp nếu student  và subject  đều được nhập
            if (paramStudent.student != 0 && paramStudent.subject != 0) {
                for (var bI = 0; bI < gGrade.length; bI++) {
                    const bItemUserObj = gGrade[bI];
                    // thực hiện so sánh từ khóa được nhập vào với dự liệu của Student
                    if (paramStudent.student === bItemUserObj.studentId &&
                        paramStudent.subject === bItemUserObj.subjectId) {
                        // thêm đối tượng thỏa mãn điều kiện vào Array
                        bArresutObj.push(bItemUserObj);
                    }
                }
            }
            // kiểm tra trường hợp nếu student  và  subject  được nhập
            else if (paramStudent.student != 0 || paramStudent.subject != 0) {
                for (var bI = 0; bI < gGrade.length; bI++) {
                    const bItemUserObj = gGrade[bI];
                    // thực hiện so sánh từ khóa được nhập vào với dự liệu của User
                    if (paramStudent.student === bItemUserObj.studentId ||
                        paramStudent.subject === bItemUserObj.subjectId) {
                        // thêm đối tượng thỏa mãn điều kiện vào Array
                        bArresutObj.push(bItemUserObj);
                    }
                }
            }
            return bArresutObj;
        }
        // hàm xử lý sự kiện Delete voucher modal click
        function onBtnConfirmDeleteStudentClick() {
            // khai báo đối tượng chứa voucher data

            // B1: Thu thập dữ liệu

            // B2: Validate update

            // B3: delete voucher
            $.ajax({
                url: gBASE_URL + "/grades/" + gStudentId,
                type: "DELETE",
                success: function (paramRes) {
                    // B4: xử lý front-end
                    handleDeleteStudentSuccess();
                },
                error: function (paramErr) {
                    console.log(paramErr.status);
                }
            });

        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

        // hàm dựa vào button detail (edit or delete) xác định đc id voucher
        function getStudentIdFromButton(paramButton) {
            var vTableRow = $(paramButton).parents("tr");
            var vStudentRowData = gStudentTable.row(vTableRow).data();
            return vStudentRowData.id;
        }
        // hàm hiện thông tin lên bảng
        function loadDataIntoTable(paramCourse) {
            gStudentTable.clear();
            gStudentTable.rows.add(paramCourse);
            gStudentTable.draw();
        }

        // hàm xử lý hiển thị front-end khi XÓA voucher thành công
        function handleDeleteStudentSuccess() {
            $(document).Toasts('create', {
                class: 'bg-success',
                title: 'Thông báo                     ',
                subtitle: 'Subtitle ',
                body: ' Đã Xóa Student của bảng thành công !'
            })

            onPageLoading();
            $("#delete-confirm-modal").modal("hide");

        }
        // hàm xử lý hiển thị front-end khi thêm voucher thành công
        function handleInsertStudentSuccess() {
            $(document).Toasts('create', {
                class: 'bg-success',
                title: 'Thông báo                     ',
                subtitle: 'Subtitle ',
                body: ' Đã thêm Student thành công vào bảng!'
            })

            resertCreateStudentForm();
            $("#create-student-modal").modal("hide");
            onPageLoading();
        }
        // hàm xử lý hiển thị front-end khi sửa voucher thành công
        function handleEditStudentSuccess() {
            $(document).Toasts('create', {
                class: 'bg-success',
                title: 'Thông báo                     ',
                subtitle: 'Subtitle ',
                body: ' Đã sửa dữ liệu của Student  này thành công!'
            })


            resetEditStudentForm();
            $("#edit-student-modal").modal("hide");
            onPageLoading();
        }
        // hàm xóa trắng form create voucher
        function resertCreateStudentForm() {
            $("#input-create-student-id").val("");
            $("#input-create-subject-id").val("");
            $("#input-create-grade").val("");
            $("#input-create-exam-date").val("");
        }
        // hàm xóa trắng form create voucher
        function resetEditStudentForm() {
            $("#input-edit-student-id").val("");
            $("#input-edit-subject-id").val("");
            $("#input-edit-grade").val("");
            $("#input-edit-exam-date").val("");
        }



    </script>


</body>
​


</html>